/*
 *                 GRAPH, Version 1.00 - 4 August 1989
 *
 *            Copyright 1989, David Gay. All Rights Reserved.
 *            This software is freely redistrubatable.
 */

#include <exec/types.h>
#include <stddef.h>
#include "list.h"
#include "tracker.h"

/* Free all elements in list (each of size size) */
void free_list(list *l, size_t size)
{
    node *scan, *next;

    for (scan = first(l); next = succ(scan); scan = next)
        FreeMem(scan, size);

    /* Be safe */
    new_list(l);
}

